/*
 * This file is part of the ESO Toolkit
 * Copyright (C) 2016 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef ESOTK_DFS_H_
#define ESOTK_DFS_H_

/*-----------------------------------------------------------------------------
                                   Includes
 -----------------------------------------------------------------------------*/

#include <cpl.h>
#include <string.h>
#include <math.h>

CPL_BEGIN_DECLS

/*-----------------------------------------------------------------------------
                                   Defines
 -----------------------------------------------------------------------------*/

/* General raw-frame */
#define ESOTK_RAW                "RAW"
#define ESOTK_RAW_CONFMAP        "RAW_CONFMAP"
#define ESOTK_RAW_BPM            "RAW_BPM"
#define ESOTK_RAW_ERROR          "RAW_ERROR"
#define ESOTK_RAW_VARIANCE       "RAW_VARIANCE"


/* Dedicated product-frames */
#define ESOTK_MASTER_FRINGE              "MASTER_FRINGE"
#define ESOTK_MASTER_FRINGE_ERROR        "MASTER_FRINGE_ERROR"
#define ESOTK_MASTER_FRINGE_CONTRIBUTION "MASTER_FRINGE_CONTRIBUTION"
#define ESOTK_MASTER_FRINGE_BPM          "MASTER_FRINGE_BPM"
#define ESOTK_FRINGE_MASK                "FRINGE_MASK"
#define ESOTK_FRINGE_CORRECTED           "FRINGE_CORRECTED"
#define ESOTK_FRINGE_CORRECTED_ERROR     "FRINGE_CORRECTED_ERROR"
#define ESOTK_FRINGE_CORRECTED_BPM       "FRINGE_CORRECTED_BPM"
#define ESOTK_WAVELENGTHS_DEST_COLLAPSE  "SPECTRUM_COLLAPSE_WLENGTHS"
#define ESOTK_SPECTRUM_1D             "SPECTRUM_1D"

/* Dedicated static-frames */
#define ESOTK_OBJ_MASK                   "OBJ_MASK"
#define ESOTK_STATIC_MASK                "STATIC_MASK"
#define ESOTK_EOP_PARAM                  "EOP_PARAM"


/*-----------------------------------------------------------------------------
                                Functions prototypes
 -----------------------------------------------------------------------------*/
cpl_error_code esotk_dfs_set_groups(cpl_frameset * set);

CPL_END_DECLS

#endif /* ESOTK_DFS_H_ */
