/*
 * This file is part of the ESO Toolkit
 * Copyright (C) 2016 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef ESOTK_MASTERFRINGE_UTILS_H_
#define ESOTK_MASTERFRINGE_UTILS_H_

/*-----------------------------------------------------------------------------
                                   Includes
 -----------------------------------------------------------------------------*/

#include "hdrl.h"

#include <cpl.h>
#include <string.h>
#include <math.h>

CPL_BEGIN_DECLS

/*-----------------------------------------------------------------------------
                                Functions prototypes
 -----------------------------------------------------------------------------*/

/* Load fringe mask */
cpl_mask * esotk_masterfringe_load_fringe_mask(cpl_frameset *fs_mask);

/* Loop over the frames */
cpl_error_code esotk_masterfringe_loop_img_frames(cpl_size extension,
	hdrl_imagelist *hlist_fringe, cpl_imagelist *clist_obj,	cpl_frameset *fs,
	cpl_frameset *fs_bpm, cpl_frameset *fs_obj, cpl_frameset *fs_err);

/* Clean parameters allocated in all the recipe */
void esotk_masterfringe_clean_all_recipe_parameters(
	cpl_frameset *fs, cpl_frameset *fs_cnf, cpl_frameset *fs_bpm,
	cpl_frameset *fs_obj, cpl_frameset *fs_err, cpl_frameset *fs_mask,
	cpl_frame *f_data, cpl_frame *f_err, cpl_frame *f_bpm,
	cpl_mask* mask, hdrl_parameter *h_Collapse,
	hdrl_image *himg_master, hdrl_imagelist *hlist_fringe, cpl_imagelist *clist_obj,
	hdrl_image *master, cpl_image  *contrib_map, cpl_table  *qctable);

/* Clean parameters allocated in the recipe */
void esotk_masterfringe_clean_loop_recipe_parameters(
	hdrl_image *himg_master, hdrl_imagelist *hlist_fringe, cpl_imagelist *clist_obj,
	hdrl_image *master, cpl_image  *contrib_map, cpl_table  *qctable);

CPL_END_DECLS

#endif /* ESOTK_MASTERFRINGE_UTILS_H_ */
